﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Goshoom.DynamicsAX
{
    /// <summary>
    /// Type of Dynamics AX AOT element.
    /// </summary>
    /// <remarks>
    /// Corresponds to AX2012 ElementTypes table, therefore it contains more
    // elements than UtilElementType enum in Dynamics AX.
    /// </remarks>
    public enum UtilElementType
    {
        Display = 1,
        Output = 2,
        Action = 3,
        Macro = 4,
        Job = 5,
        WorkflowProcess = 6,
        AdminSetup = 7,
        SysXal = 8,
        UserSetupQuery = 9,
        LegacyMenu = 10,
        Form = 11,
        TableInstanceMethod = 12,
        StaticClassMethod = 13,
        InstanceClassMethod = 14,
        LicenseCode = 15,
        Menu = 16,
        UserMenu = 17,
        Report = 18,
        ReportTemplate = 19,
        Query = 20,
        Resource = 21,
        TableStaticMethod = 22,
        ClassHeader = 23,
        TableHeader = 24,
        TableRelation = 25,
        Map = 26,
        ReportSectionTemplate = 27,
        ViewQuery = 28,
        UserSetup = 29,
        WebMenu = 30,
        WebForm = 34,
        ConfigurationKey = 35,
        SecurityKey = 36,
        SharedProject = 37,
        PrivateProject = 38,
        LegacyFeatureKey = 39,
        BaseEnum = 40,
        ExtendedDataType = 41,
        TableField = 42,
        TableIndex = 43,
        Table = 44,
        Class = 45,
        TableFieldGroup = 46,
        ReportUser = 47,
        TableCollection = 48,
        WebReport = 52,
        Reference = 53,
        WebURLItem = 55,
        WebActionItem = 56,
        WebDisplayContentItem = 57,
        WebOutputContentItem = 58,
        WebletItem = 59,
        WebPart = 60,
        WebSiteDef = 61,
        WebSiteTemp = 62,
        WebPageDef = 63,
        WebStaticFile = 64,
        Perspective = 66,
        WebModule = 67,
        WorkflowTemplate = 68,
        WorkflowTask = 69,
        WorkflowApproval = 70,
        WorkflowCategory = 71,
        Dataset = 72,
        WebControl = 73,
        WebSourceFile = 74,
        WebManagedContentItem = 75,
        Service = 76,
        CompositeQueryNode = 77,
        WebListDefinition = 78,
        ReportLibrary = 79,
        SecurityTask = 80,
        InfoPart = 81,
        FormPart = 82,
        PartReference = 83,
        SSRSReport = 85,
        SSRSReportLayoutTemplate = 87,
        SSRSReportListStyleTemplate = 88,
        SSRSReportMatrixStyleTemplate = 89,
        SSRSReportPieChartStyleTemplate = 90,
        SSRSReportTableStyleTemplate = 91,
        SSRSReportXYChartStyleTemplate = 92,
        SSRSReportDatasource = 93,
        SSRSReportImage = 94,
        WorkflowAutomatedTask = 95,
        Event = 96,
        EventHandler = 97,
        Cue = 98,
        CueGroup = 99,
        CueReference = 100,
        DocumentSet = 101,
        VisualStudioProjectFolder = 104,
        VisualStudioProjectFile = 105,
        InfoPartLayout = 106,
        InfoPartGroup = 107,
        InfoPartField = 108,
        InfoPartAction = 109,
        MenuItem = 110,
        MenuSeparator = 111,
        MenuReference = 112,
        FullTextIndex = 113,
        VisualStudioProjectType = 114,
        SecurityCodePermission = 115,
        EventHandlerMethod = 116,
        LabelFile = 117,
        LabelFileLanguage = 118,
        SecurityPolicy = 119,
        FormMethod = 120,
        VisualStudioProjectLink = 121,
        SubMenu = 122,
        SubWebMenu = 123,
        SubWebModule = 124,
        FormDesign = 125,
        FormControl = 126,
        VisualStudioProjectAXModel = 127,
        VisualStudioProjectCSharp = 128,
        VisualStudioProjectVB = 129,
        VisualStudioProjectWeb = 130,
        VisualStudioProjectAnalysis = 131,
        SecurityRole = 133,
        SecurityPrivilege = 134,
        SecurityDuty = 135,
        SecurityProcessCycle = 136,
        ServiceGroup = 137,
        ServiceNodeReference = 138,
        WorklowHierarchyProvider = 139,
        WorklowParticipantProvider = 140,
        WorkflowQueueProvider = 141,
        WorkflowDueDateProvider = 142,
        FormDataSources = 143,
        SecurityPermissionSet = 144
    }
}
